// kontroll.c
// 1998-04-12 programmeerimisvistluse 3. lesande testija
// Autor: Ahto Truu

#include <stdio.h>
#include <stdlib.h>

int main (int argc, char **argv)
{
	int *var[3], arv[3];
	FILE *f;
	int c, c1, c2;
	int i, n;

	if (argc < 3) {
		fprintf (stderr, "Sntaks on %s sisend vljund\n", argv[0]);
		return 0;
	}

	if ((f = fopen (argv[1], "rt")) == NULL) {
		fprintf (stderr, "Viga faili %s avamisel\n", argv[1]);
		return 0;
	}
	while ((c = fgetc (f)) != EOF && c != '*')
		;
	for (n = 1; (c = fgetc (f)) == '*'; ++n)
		;
	fclose (f);

	for (i = 0; i < 3; ++i)
		if ((var[i] = malloc (n * sizeof (int))) == NULL) {
			fprintf (stderr, "Mlu otsas\n");
			return 0;
		}
	arv[0] = n; arv[1] = 0; arv[2] = 0;
	for (i = 0; i < n; ++i)
		var[0][i] = -i;

	if ((f = fopen (argv[2], "rt")) == NULL) {
		fprintf (stderr, "Viga faili %s avamisel\n", argv[2]);
		return 0;
	}
	while ((c1 = fgetc (f)) != EOF && c1 != '\n') {
		if (c1 < '1' || c1 > '3') {
			fprintf (stderr, "Lubamatu sisendsmbol \"%c\"\n", c1);
			return 0;
		}
		if ((c2 = fgetc (f)) < '1' || c2 > '3') {
			fprintf (stderr, "Lubamatu sisendsmbol \"%c\"\n", c1);
			return 0;
		}
		c1 -= '1'; c2 -= '1';
		if (arv[c1] == 0) {
			fprintf (stderr, "Thi varras %c\n", c1);
			return 0;
		}
		if (arv[c2] > 0 && var[c1][arv[c1] - 1] > var[c2][arv[c2] - 1]) {
			fprintf (stderr, "Suurem ketas viksema peale\n");
			return 0;
		}
		--arv[c1];
		var[c2][arv[c2]] = var[c1][arv[c1]];
		++arv[c2];
	}
	fclose (f);

	if (arv[0] > 0 || arv[1] > 0 || arv[2] < n) {
		fprintf (stderr, "Kik kettad pole vardal 3\n");
		return 0;
	}

	fprintf (stderr, "Korras\n");
	return 0;
}